import img.Picture;
import img.Pixel;

import java.awt.Color;
import java.io.File;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Date;
import java.util.Scanner;

import javax.swing.JFileChooser;

public class L14App3 {
	public static void main(String[] args) {
		PrintStream output = System.out;

		/*
		 * Construct an image object from the following file (assume the file is
		 * present): "/Users/mb/000_images_1710/treefrog.jpg"
		 */
		String myPathName = File.separator + "Users" + File.separator + "mb"
				+ File.separator + "000_images_1710" + File.separator
				+ "treefrog.jpg";
		Picture myPict = new Picture(myPathName);
		myPict.show();

		// Now derive a reference to the pixel object that encapsulates the
		// pixel that occurs in the top left-hand corner

		final int ROW_INDEX = 0;
		final int COL_INDEX = 0;
		Pixel thePixel1 = myPict.getPixel(COL_INDEX, ROW_INDEX);
		// now construct another object
		Pixel thePixel2;
		thePixel2 = new Pixel(myPict, COL_INDEX, ROW_INDEX);

		System.out.println(thePixel1);
		System.out.println(thePixel2);
		// show the objects are distinct in memory
		boolean test1 = thePixel1 == thePixel2;
		boolean test2 = thePixel1.equals(thePixel2);
		System.out.println(test1);
		System.out.println(test2);
		// we mutate the one object
		thePixel2.setColor(Color.BLACK);
		// we see the effect on the picture
		// we can see an effect if we mutate the other object as well.
		myPict.explore();

		// why does this happen? because part of the pixel object's state is the
		// image to which it belongs. When a component of the Picture changes,
		// the picture changes. When the picture changes, all pixel objects
		// defined relative to it change as well.

		// both objects, albeit different objects, share this particular
		// attribute (the picture to which they belong)
		System.out.println(thePixel1);
	}
}
